"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function applyMiddleware(middlewares, ctx) {
    return function (value, promisify, cancel) {
        var n = function (effect) { return effect; };
        var compose = function (acc, md) { return md.call(ctx, acc); };
        var chain = middlewares.reduce(compose, n);
        return chain(value, promisify, cancel);
    };
}
exports.default = applyMiddleware;
//# sourceMappingURL=apply-middleware.js.map