import { Middleware } from './types';
export interface Runtime<Fn extends (...args: any[]) => any> {
    fn: Fn;
    args?: Parameters<Fn>;
    cancel?: Promise<any>;
}
declare function factory(...middleware: Middleware[]): {
    <Fn extends (...args: any[]) => any, V = any>(this: any, gen: Runtime<Fn>, ...args: any[]): Promise<V>;
    <Fn extends (...args: any[]) => any, V = any>(this: any, gen: Fn, ...args: Parameters<Fn>): Promise<V>;
};
export default factory;
