"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var runtime_1 = require("./runtime");
function factory() {
    var middleware = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        middleware[_i] = arguments[_i];
    }
    function externalRuntime(gen) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var ctx = this;
        if (typeof gen === 'function') {
            return runtime_1.default.call(ctx, {
                fn: gen,
                args: args,
                middleware: middleware,
            });
        }
        return runtime_1.default.call(ctx, __assign({}, gen, { middleware: middleware }));
    }
    return externalRuntime;
}
exports.default = factory;
//# sourceMappingURL=factory.js.map