"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isPromise(obj) {
    return 'function' == typeof obj.then;
}
exports.isPromise = isPromise;
function isGenerator(obj) {
    return 'function' == typeof obj.next && 'function' == typeof obj.throw;
}
exports.isGenerator = isGenerator;
function isGeneratorFunction(obj) {
    var constructor = obj.constructor;
    var name = constructor.name;
    var displayName = constructor.displayName;
    if (!constructor) {
        return false;
    }
    if (name === 'GeneratorFunction' || displayName === 'GeneratorFunction') {
        return true;
    }
    return isGenerator(constructor.prototype);
}
exports.isGeneratorFunction = isGeneratorFunction;
function isObject(val) {
    return Object == val.constructor;
}
exports.isObject = isObject;
//# sourceMappingURL=is.js.map