import { Middleware } from './types';
interface BaseRuntime<Fn extends (...args: any[]) => any> {
    fn: Fn;
    args?: Parameters<Fn>;
    cancel?: Promise<any>;
    middleware?: Middleware[];
}
export default function runtime<V, Fn extends (...args: any[]) => any>(this: any, { fn, args, cancel, middleware }: BaseRuntime<Fn>): Promise<V>;
export {};
